transcript fbase();
  comment  'final subtypes';
--ftype(e,b) is an expanded form of base_link, where b is the subtype of e,
--  such that the type vars of b are bases
--ftype3 is undefined
--ftype4 is undefined
--transub(i,set(j),k) if i <* set(j), and k is the actual base variable in j
--fbase(b) if ffbase(b) or...
--fsubtype(b,t) is a reduced form of subtype with intermediate type variables
--  removed if they aren't based
--based(x) if type variable x is truly based
--ffbase(b) ...
--temp(v,b) if v isn't basible but arb v is, and btype(v,set(b))
  rel ftype, ftype3, ftype4 : [tree, typexpr];
      transub: [typexpr, typexpr, typexpr];
      fbase: [typexpr];
      fsubtype: [typexpr, typexpr];
      based, ffbase: [typexpr];
      temp: [tree, typexpr];
  prompt ftype: ['ftype: ', 1, ': ', 2];
         fsubtype: ['fsubtype: ', 1, ' < ', 2];
         based: [1, ' : base '];
  external
     base_link, btype: [tree, typexpr];
     subtype: [typexpr, typexpr];
     based0, base: [typexpr];
  incremental fsubtype: unify;
  key ftype, fbase, based, fsubtype: [1];
begin
   base_link(.v, .i) and base(.i)
   -> ftype(.v, .i) and ffbase(.i);

   ffbase(.i) and base(.i)
   -> based(.i);            --inferred bases are based

   based0(.i) -> based(.i); --declared bases are based

   ffbase(.i)
   -> fbase(.i);
   ffbase(.i) and transub(.i, .j, .k)
   -> fsubtype(.i, .j) and ffbase(.k);
   btype(.v, [set,.i]) and null(z,base_link(.v, z))
   ->   temp(.v, .i);   -- v isn't basible, but arb v is
   temp(.v, .i) and base(.i)
   ->   ftype(.v, [set,.i]) and ffbase(.i);
   temp(.v, .i) and not(base(.i)) and transub(.i, .j, .k)
   -> ftype(.v, .j) and ffbase(.k);
   subtype(.v, [set, .i]) and base(.i)
   ->   fbase(.i);
   subtype(.v, [set, .i]) and null(z,subtype(.i, z))
   -> fbase(.i);
   base_link(.v, .i) and null(z,subtype(.i, z))
   -> ftype(.v, .i) and fbase(.i);
   temp(.v, .i) and null(z,subtype(.i, z))
   -> ftype(.v, [set,.i]) and fbase(.i);
-- tuple types here are bugs, or they aren't used-----------------
   subtype(.v, [tuple, [.i, .j]]) and null(z,subtype(.j, z))
   -> fbase(.j);
   subtype(.v, [tuple, [.i, .j]]) and null(z,subtype(.i, z))
   -> fbase(.i);
   subtype(.v, [tuple, [.i, .j]]) and base(.j)
   -> fbase(.j);
   subtype(.v, [tuple, [.i, .j]]) and base(.i)
   -> fbase(.i);
-------------------------------------------------------------------
   subtype(.i, [set, .j]) and fbase(.j)
   -> transub(.i, [set, .j], .j);
   subtype(.i, [set, .j]) and transub(.j, .k, .l) and not(base(.j))
   -> transub(.i, [set, .k], .l); 
   base_link(.v, .i) and not(base(.i)) and transub(.i, .j, .k)
   -> ftype(.v, .j) and ffbase(.k);
------bug!! these tuple rules probably aren't used----------------------
   subtype(.t, [tuple, [.i, .j]]) and fbase(.i) and fbase(.j)
   -> transub(.t, [tuple, [.i, .j]], [.i, .j]);
   subtype(.t, [tuple, [.i, .j]]) and transub(.i, .i1, .i2) 
         and transub(.j, .j1, .j2) and not(base(.i)) and not(base(.j))
   -> transub(.t, [tuple, [.i1, .j1]], [.i2, .j2]);
   subtype(.t, [tuple, [.i, .j]]) and transub(.i, .i1, .i2) 
         and not(base(.i)) and fbase(.j)
   -> transub(.t, [tuple, [.i1, .j]], [.i2, .j]);
   subtype(.t, [tuple, [.i, .j]]) and transub(.j, .j1, .j2) 
         and not(base(.j)) and fbase(.i)
   -> transub(.t, [tuple, [.i, .j1]], [.i, .j2]);
-------------------------------------------------------------------------
   ffbase([.i, .j])
   ->  ffbase(.i) and ffbase(.j);

end;




