transcript freevar();
  comment   'finding free variables';
--freevar(e,x) where x is a free variable of expression or lexpression e
--free(x) where x is a free variable of a read or print statement, or top level
  rel freevar: [node, tree];
      free: [tree];
  prompt free:  [1, ' is a free variable '];
  external bvar: [node, tree];
           op: [node, node];
           isbvar: [tree];
  language  setl;
  key     free: [1];
begin
  match(%statement, read(.x);%)
  | freevar(.x, .y)
  -> free(.y);
  match(%statement, print(.x);%)
  | freevar(.x, .y)
  -> free(.y);
  freevar(root(), .x) 
  -> free(.x);
  match(%expr, .x %) 
  | isavar(%expr, .x%) 
  -> freevar(%expr, .x%, %expr, .x%);
  match(%lexpr, .x %) 
  | isavar(%lexpr, .x%) 
  -> freevar(%lexpr, .x%, %expr, .x%);
  op(.x, .y) and  freevar(.y, .z) and not bvar(.x, .z)
  -> freevar(.x, .z);
  freevar(.y, .z) and  not isbvar(.z) -- this rule is goofed up
  -> free(.z);
end;
