    transcript mono () ; 
      comment 'testing monotonicity' ; 
--mono(x,y) where x is monotone in y
--anti(x,y) where x is antimonotone in y
--inv(z) where z is an expression where the bound var. of some fp expr is
--  neither free nor bound in z
      rel mono, anti : [ tree, tree];
          inv: [tree];  -- inv is goofed up
      assumption mono, anti: open_world;
      prompt mono : [ 1 , '^' , 'is monotone in ' , '^' , 2 ] ; 
             anti : [ 1 , '^' , 'is anti-monotone in ' , '^' , 2 ] ; 
      language setl ; 
      key mono, anti: [1];
      external freevar: [node, tree];
               monexpr1: [tree, tree];
               monexpr2: [tree, tree, tree];
               stream: [tree];
               bvar: [node, tree];
      begin 
        stream(.t) -> mono(.t, .t);
       match(%expr, .x%)
        | stream(.t) and not freevar(%expr, .x%, .t)
          and not bvar(%expr, .x%, .t) 
        -> inv(%expr, .x%) and mono (%expr, .x%, .t) 
           and anti(%expr, .x%, .t);
        monexpr1( .t, .t1 ) and mono(.t1, .t2) 
        -> mono( .t , .t2 ) ;
        monexpr1( .t, .t1 ) and anti(.t1, .t2) 
        -> anti( .t , .t2 ) ;
        monexpr2( .t, .t1, .t2 ) and mono(.t1, .s) and mono(.t2, .s) 
        -> mono( .t , .s ) ;
        monexpr2( .t, .t1, .t2 ) and anti(.t1, .s) and anti(.t2, .s) 
        -> anti( .t , .s) ;
        match(%expr, .x - .y%)
        |  mono(%expr, .x%, .t) and anti(%expr, .y%, .t)
        -> mono(%expr, .x - .y%, .t);
        match(%expr, .x - .y%)
        |  anti(%expr, .x%, .t) and mono(%expr, .y%, .t)
        -> anti(%expr, .x - .y%, .t);
        match(%expr, .x = {}%)
        |  mono(%expr, .x%, .t)
        -> anti(%expr, .x = {}%, .t);
        match(%expr, .x = {}%)
        |  anti(%expr, .x%, .t)
        -> mono(%expr, .x = {}%, .t);
        match(%expr, not .x %)
        |  mono(%expr, .x%, .t)
        -> anti(%expr, not .x%, .t);
        match(%expr, not .x %)
        |  anti(%expr, .x%, .t)
        -> mono(%expr, not .x%, .t);
        match(%expr, .x notin .y %)
        |  mono(%expr, .y%, .t) and inv(%expr, .x%)
        -> anti(%expr, .x notin .y%, .t);
        match(%expr, .x notin .y %)
        |  anti(%expr, .y%, .t) and inv(%expr, .x%)
        -> mono(%expr, .x notin .y%, .t);
        match(%expr, .x subset .y %)
        |  mono(%expr, .y%, .t) and anti(%expr, .x%, .t)
        -> mono(%expr, .x subset .y%, .t);
        match(%expr, .x subset .y %)
        |  mono(%expr, .x%, .t) and anti(%expr, .y%, .t)
        -> anti(%expr, .x subset .y%, .t);
        match(%expr, .x > .y%)
        |  mono(%expr, .x%, .t) and anti(%expr, .y%, .t)
        -> mono(%expr, .x > .y%, .t);
        match(%expr, .x > .y%)
        |  anti(%expr, .x%, .t) and mono(%expr, .y%, .t)
        -> anti(%expr, .x > .y%, .t);
        match(%expr, .x = 0%)
        |  mono(%expr, .x%, .t)
        -> anti(%expr, .x  = 0%, .t);
        match(%expr, .x = 0%)
        |  anti(%expr, .x%, .t)
        -> mono(%expr, .x  = 0%, .t);
        match(%expr, {.e1: .x in .e2  | .e3}%)
        |  mono(%expr, .e3%, .t) and mono(%expr, .e2%, .t) and inv(%expr,.e1%)
        -> mono(%expr, {.e1: .x in .e2  | .e3}%, .t);
        match(%expr, {.e1: .x in .e2  | .e3}%)
        |  anti(%expr, .e3%, .t) and anti(%expr, .e2%, .t) and inv(%expr,.e1%)
        -> anti(%expr, {.e1: .x in .e2  | .e3}%, .t);
      end ; 











