#include "timer.h"
#include <stdio.h>
#include <string.h>
#define true 1
#define false 0
#define Bsize 10
#define maxline 100
#define dum tty
#define alloccell alloc_cell() 
#define arrayelem(h, i, t)    h[i].t
#define free(x) return_cell(x) 
#define get_field(x,f) (x)->data.f
#define get_fieldv(x,f) (x).f
#define getimage(x,y,b)            b.recs[x].y.image
#define getimagew(x) (x)->data.image
#define getmapval(e,m,b)  b.recs[e].m.image
#define getnext(s,b,e)  b.recs[e].s.next
#define getkeyimage(x,b)  b.recs[x].key
#define getnextw(x) (x)->next
#define getfirstw(x) (x)->next
#define print_str(x,y)    fprintf(x,y) 
#define print_newline(x)  fprintf(x,"\n")
#define emptytuple(x)  x=alloccell
#define is_emptyw(x)  (x->next == NULL)
#define emptyrecord(n)  x=alloc_tuple(n)
#define om NULL
#define POOL_SIZE 100000
#define recelem(a,b,c)  a[b-1].c
#define emptys(v,b)   b.firsts.v = 0
#define emptyw(v,b)   v = alloccell
#define emptyub(v)   v = alloccell
#define getfirst(s,b) b.firsts.s
#define stl_open(x,y) c_open(x,y)
#define stl_close(x)  fclose(x)
#define print(x)     printf(x)
#define printa(x,y)  c_print(x,y)
#define geta(h,line)  c_geta(h, &line)

#define str_const(x)  string("x")

#define compare(x,y,z)  z((x),(y))

#define lt(x,y)      x < y

#define gt(x,y)      x > y

#define eq(x,y)      x = y

#define le(x,y)      x <= y

#define ge(x,y)      x >= y

#define eof(dum)  c_eof

#define tty  stdout

#define getfuncval(e , m , b , t)    get_funcv(b.recs [e].m.image)->data.t

typedef union poly polycell, *polycellp;



#define enter_base(x,y,b);           \
{ b . size += 1;                     \
  b . recs [ b . size ] . key = y;   \
  x = b . size ;                     \
}                                    \

#define enter_base1(y,b)           \
( b . size += 1,                     \
  b . recs [ b . size ] . key = y,   \
  b . size                      \
)                                

int utime, c_eof;

char line[maxline];

#define begin  {printf("begin: 0 ms. \n"); utime = user_time();}

#define end  printf("end: %d ms.\n", user_time() - utime)


typedef struct node cell, *cellp;
typedef int *intp;
typedef char *charp;
typedef FILE *filep;
typedef struct datat elem, *elemp;

union poly {
int intv;
char *strv;
cellp ptrv;
};

struct datat {
int val;
int intv;
char *strv;
elem *elempv;
cell * cellpv;
cell * image;
};

struct node { 
  struct datat data;
  cell * next, *prev; 
};

struct { cell * p, * p1, *h;
	 long i, i1 ;
       } pool;

void pool_init() {
  pool.i = 0;
  pool.p1 = NULL;
  pool.i1 = 0;
}


/*
cell * alloc_cell()
 {
  cell *cp;
  if (pool.i == 0 ) {
    if (pool.i1 == 0) {
      pool.p = (cell*) malloc(POOL_SIZE * sizeof(cell));
      pool.i = POOL_SIZE;
    } 
    else {
      cp = pool.p1;
      pool.p1 = cp->next;
      pool.i1 -=1;
      cp -> next = NULL;
      cp -> data.image = NULL;
      return cp;
    }
  }
  cp = pool.p;
  pool.i -= 1;
  pool.p += 1;
  cp->next = NULL;
  cp -> data.image = NULL;
  return cp;
}

*/

#define alloc_tuple(sz) \
    (elem*)malloc(sizeof(elem)*sz)

#define  alloc_cell()        \
 ( ( pool.i == 0)?                           \
      ( (pool.i1 == 0) ?                        \
        (  pool.p = (cell*) malloc(POOL_SIZE * sizeof(cell)),          \
           ( (pool.p == 0)? (printf("memory exauhsted\n"), abort()):    \
                            1),                                \
           pool.i = POOL_SIZE -1 ,                       \
           pool.p->next = NULL,                               \
           pool.p->prev = NULL,                               \
           pool.p -> data.image = NULL,                       \
           pool.p ++                                   \
        ):                                            \
        (  pool.h = pool.p1,                        \
           pool.p1 = pool.h->next,                       \
           pool.h -> data.image = NULL,                  \
           pool.h -> next = NULL,                  \
           pool.h -> prev = NULL,                  \
           pool.i1 -=1,                              \
           pool.h                             \
        )                                           \
      ):                                       \
      ( pool.i -= 1,                                        \
        pool.p -> next = NULL,                               \
        pool.p -> prev = NULL,                               \
        pool.p -> data.image = NULL,                       \
        pool.p ++                                     \
      )                                             \
  )

#define return_cell(p)     \
{                           \
  p->next = pool.p1;        \
  pool.i1 += 1;             \
  pool.p1 = p;              \
}


/*
void  return_cell(p)     
cell *p;
{                           
  p->next = pool.p1;        
  pool.i1 += 1;             
  pool.p1 = p;              
}

*/

typedef struct { 
  int mem, next, prev; 
} set_rec;

typedef struct { 
  int mem, next, prev; 
  cell * image;
} map_rec;


#define PRINT_SBSET(h, x, y)    {                          \
  int i;                                               \
  i = x.firsts.y;                                      \
  while ( i != 0 ) {                                   \
    fprintf(h, "%d,  %d \n", i,    x.recs[i].key);                     \
    i = x.recs[i].y.next;                              \
  };                                                   \
  }                                                    

#define PRINT_KEY(h, b)    {                          \
  int i;                                               \
  fprintf(h, "keys: \n");           \
  for (i = 1; i <= b.size; i++)                                      \
    fprintf(h, "%d,  %d \n", i,    b.recs[i].key);                     \
  }                                                    

#define PRINT_WBSET(h, b, x)  {   					\
   cell * tt;  				\
   tt = x->next;				\
   while (tt) {				\
	fprintf(h, "%d, %d \n", tt->data.val, b.recs[tt->data.val].key );   \
	tt = tt-> next;			\
   }					\
  }                                     

void print_int(h, i)
int i;
{
fprintf((FILE *)h, "%d ", i);

}

char * int_str(i)
int i;
{ char tmp[50];
  sprintf(tmp, "%d", i);
  return strdup(tmp);
}

int exists(x, d) 
cell * * x;
cellp d;
{
	if ( d->next ) {
		*x = d->next; 
		return 1;
	}
	else 	return NULL;
}

#define  get_funcv(p)            \
 (  (p->next)?(p->next): (p->next=alloccell,     \
                                 p->next)         \
 )

cellp image_set(x, f)
int x;
cellp f;
{ cellp i;
  for (i = f->next; i; i = i->next)
    if (i ->data.image->data.val == x)
      return i->data.image->data.image;
  return NULL;
};

void  print_string(h, s)
char * s ;
{
fprintf((FILE *)h, s);
}


char*  string(s)
char * s ;
{
char * tmp;
int i, j;
j = 0;
tmp = (char *) malloc(strlen(s));
tmp[0] = 0;
for (i = 0; s[i] != '\''; i++);
for (i++; s[i] != '\''; i++){
tmp[j] = s[i];
j++;
}
return tmp;
}

FILE* c_open(x,y)
char * x, *y ;
{
  char * r = "text-in",
       * w = "text-out";
  FILE * h;
  if ( strncasecmp(y,r,7)==0)
    return fopen(x,"r");
  else
    if ( strncasecmp(y,w,8)==0)
      return fopen(x, "w");
}

void c_print(x,y)
char * x, *y ;
{
  fprintf((FILE *)x,y);
}

void c_geta(h,y)
FILE *h;
char **y;
{char tmp[maxline+1];
 fgets(tmp, maxline, h);
 *y = strdup(tmp);
 c_eof = getc(h);
 ungetc(c_eof, h);
 c_eof = (c_eof == EOF);
};

#define addub(x,t,s);               \
{                                        \
  cell * p , * of ;                      \
  if (s == NULL)                         \
     s = alloccell ;                    \
  p = alloccell ;                       \
  of = s -> next ;                      \
  p -> next = of ;                      \
  p -> data . t = x ;                   \
  if ( of != NULL )                     \
    of -> prev = p ;                    \
  else                                  \
     s -> prev = p ;                    \
  s -> next = p ;                       \
}                                       

#define mfield_init(b,v)  b.recs[b.size].v.mem = 0
#define sfield_init(b,v)  b.recs[b.size].v.mem = 0

